// -*- C++ -*-

// Interface for subclass of Connect: subclassed to add ctor for netcdf.
//
// jhrg 9/29/94

/* $Log: JGConnect.h,v $
/* Revision 1.7  1999/05/05 04:38:00  brent
/* convert String.h code to new stanard lib <string>
/*
/* Revision 1.6  1997/03/10 22:53:21  dan
/* Changed the return type of JGConnect::request_data to pointer from
/* reference.
/*
 * Revision 1.5  1997/02/19 02:12:50  jimg
 * Fixed newest_dds() and request_dds() return type.
 *
 * Revision 1.4  1996/09/19 20:56:00  jimg
 * Made the JGConnect dtor virtual.
 *
 * Revision 1.3  1996/09/17 00:02:08  jimg
 * Misc changes associated with merging branch code to the trunk.
 *
 * Revision 1.2.8.1.2.1  1996/06/26 22:17:45  jimg
 * Dans changes for 2.05.
 *
 * Revision 1.2  1995/03/14  01:21:13  jimg
 * Removed code copied over from the netcdf subclass of Connect.
 *
 * Revision 1.1  1995/01/09  16:03:34  dan
 * These files constitute the JGOFS server and client library code
 * for use with the DODS api.
 *
 * Revision 1.6  1994/11/23  20:59:54  reza
 * Added heuristic dimension matching for Grid and Array classes.
 * Added Dimension handling routines (ndims(), dim_size(), dim_name(),
 * parse_dim(),and etc.)
 *
 * Revision 1.5  1994/11/18  21:33:32  reza
 * Added _nvars and nvars() for number of variables in the file.
 * Added _das_loc[] and parse_das_loc() to make a look-up table for variables
 * in dds vs. das.
 *
 * Revision 1.4  1994/11/03  05:45:08  reza
 * Moved error, request_das, and request _dds to the surrogate library for more
 * flexibility and simpler error handling.
 *
 * Revision 1.3  1994/10/28  19:09:04  jimg
 * Added _error, error() and fixed ncid() so that it retruns a reference.
 *
 * Revision 1.2  1994/10/05  20:23:31  jimg
 * Fixed errors in *.h files comments - CVS bites again.
 * Changed request_{das,dds} so that they use the field `_api_name'
 * instead of requiring callers to pass the api name.
 *
 * Revision 1.1  1994/10/05  18:02:15  jimg
 * First version of the connection management classes.
 * This commit also includes early versions of the test code.
 */

#ifndef _jg_connect_h
#define _jg_connect_h

#ifdef __GNUG__
#pragma "interface"
#endif

#include "Connect.h"

class JGConnect: public Connect {
private:
    DDS *_newest_dds;
    int _jgid;			// used only if LOCAL is true, otherwise == -1

public:
    JGConnect(const string &name, const bool verbose = false);
    virtual ~JGConnect();

    DDS *newest_dds();
    DDS *request_data(const string expr, bool gui_p, bool async = false, 
		      const string &ext = "dods");
    int jgid();
};

typedef JGConnect * JGConnectPtr;

#endif

